#include <iostream.h>
#include <math.h>
#include <stdlib.h>

#include "Vector.h"

Vector::Vector()
{
	m_size = 0;
	m_pv = new int[1];
}


Vector::Vector(int tamany)
{
	m_size = tamany;
	m_pv = new int[tamany];
	for (int i=0; i <tamany; i++) // Inicialitzem tot el vector amb 0
		m_pv[i] = i;
}


Vector::Vector(int* p, int tamany)
{
	int i;
	
	m_pv = new int[tamany];
	m_size = tamany;
	
	for (i=0; i<tamany; i++)
		m_pv[i] = p[i];			
}


Vector::~Vector()
{
	//delete [] m_pv;
}


int Vector::Mida()
{
	return m_size;
}


Vector & Vector::operator = (const Vector& a)
{
	m_size = a.m_size;
	if (this != &a) // per evitar a = a
	{
		for(int i=0; i < m_size; i++)//a.m_size; i++)
		{
			m_pv[i] = a.m_pv[i];
		}
	}
	return(*this);
}

// No entenc que ha de fer aquesta funci
int& Vector::operator[](int a)
{
	return m_pv[a];
}

// No entenc que ha de fer aquesta funci
int Vector::operator[](int a) const
{
	return m_pv[a];
}


Vector& Vector::operator+=(const Vector& a)
{
	if (m_size = a.m_size)
	{
		for (int i=0; i < m_size; i++)
		{
			m_pv[i] = a.m_pv[i] + m_pv[i];
			cout << "La suma es: " << m_pv[i] << endl;
		}
	}
	else
	{
		cout << " Els tamanys son diferents. " << endl;
	}
	return (*this);
}


Vector operator+(const Vector& a, const Vector& b)
{
	Vector final;

	if (a.m_size < b.m_size) 
	{
		final.m_size = b.m_size;
	}
	else
	{
		final.m_size = a.m_size;
	}
	
	for (int i=0; i < final.m_size; i++)
	{
		final.m_pv[i] = a.m_pv[i] + b.m_pv[i];
		cout << " La suma final es: " << final.m_pv[i] << endl;
	}
	 return (final);
}


bool operator==(const Vector& a, const Vector& b)
{
	int i=0;
	bool final = true;
	/*
	 Coses que poden pasar pq no siguin iguals
	 1- Tinguin diferent tamany.
	 2- El vector tingui elements diferents
	*/

	if (a.m_size != b.m_size) // Comprovem que tinguin el mateix tamany
	{
		cout << " Tamany diferent per tant son diferents!! " << endl;
		return false;
	}
	else
	{
		cout << " Tenen el mateix tamany. "<< endl;
		while (i < a.m_size && final) // recorrem els vectors comparant els elements entre si
		{
			final = (a.m_pv[i] == b.m_pv[i]); 
			i++;
		}

		return (final);
	}
}


ostream& operator<<(ostream& out , Vector& a)
{
	if (a.m_size == 0)
	{
		out << " Vector buit "<< endl << endl;
	}
	else
	{
		for (int i=0; i < a.m_size ; i++)
		{
			out << a.m_pv[i] << "  ";
		}
		out << endl << endl;
	}
	return(out);
}


// Per entrar el vector. Tb podriem fer un mtode.
istream& operator >>(istream& in, Vector& a)
{
	cout << " Tamany del vector: ";
	in >> a.m_size;
	cout << endl << endl << " Anem a entrar el vector en si: " << endl;
	for (int i=0; i<a.m_size;i++)
	{
		cout << "Vector[" << i <<"]= ";
		in >> a.m_pv[i];
		cout << endl;
	}
	return(in);	
}
