#ifndef VECTOR_H
#define VECTOR_H

class Vector
{
	private:
		int m_size;
		int *m_pv;

	public:
		//Constructors
		Vector();
		Vector(int);
		Vector(int *, int); //Primer parmetre el punter, segon el nombre d'elements.
		// Destructor
		~Vector();

		int Mida();
		Vector& operator=(const Vector&);
		int& operator[](int );
		int operator[](int ) const;
		Vector& operator+=(const Vector&);
		friend Vector operator+(const Vector&, const Vector&);
		friend bool operator==(const Vector&, const Vector&);
		friend ostream& operator<<(ostream& , Vector& );
		// Per entrar el vector. Tb podriem fer un mtode.
		friend istream& operator >>(istream&, Vector&);
};

#endif
